--- old/usr/src/cmd/ptools/pflags/pflags.c	Wed Apr 12 20:33:20 2023
+++ new/usr/src/cmd/ptools/pflags/pflags.c	Wed Apr 12 20:33:20 2023
@@ -53,9 +53,6 @@
 static	char	*prwhy(int);
 static	char	*prwhat(int, int);
 static	void	dumpregs(const prgregset_t, int);
-#if defined(__sparc) && defined(_ILP32)
-static	void	dumpregs_v8p(const prgregset_t, const prxregset_t *, int);
-#endif
 
 static	char	*command;
 static	struct	ps_prochandle *Pr;
@@ -349,22 +346,10 @@
 
 	if (rflag) {
 		if (Pstate(Pr) == PS_DEAD || (arg->pflags & PR_STOPPED)) {
-#if defined(__sparc) && defined(_ILP32)
-			/*
-			 * If we're SPARC/32-bit, see if we can get extra
-			 * register state for this lwp.  If it's a v8plus
-			 * program, print the 64-bit register values.
-			 */
-			prxregset_t prx;
-
-			if (Plwp_getxregs(Pr, psp->pr_lwpid, &prx) == 0 &&
-			    prx.pr_type == XR_TYPE_V8P)
-				dumpregs_v8p(psp->pr_reg, &prx, is64);
-			else
-#endif	/* __sparc && _ILP32 */
-				dumpregs(psp->pr_reg, is64);
-		} else
+			dumpregs(psp->pr_reg, is64);
+		} else {
 			(void) printf("\tNot stopped, can't show registers\n");
+		}
 	}
 
 	return (0);
@@ -507,20 +492,6 @@
 	return (str);
 }
 
-#if defined(__sparc)
-static const char * const regname[NPRGREG] = {
-	" %g0", " %g1", " %g2", " %g3", " %g4", " %g5", " %g6", " %g7",
-	" %o0", " %o1", " %o2", " %o3", " %o4", " %o5", " %sp", " %o7",
-	" %l0", " %l1", " %l2", " %l3", " %l4", " %l5", " %l6", " %l7",
-	" %i0", " %i1", " %i2", " %i3", " %i4", " %i5", " %fp", " %i7",
-#ifdef __sparcv9
-	"%ccr", " %pc", "%npc", "  %y", "%asi", "%fprs"
-#else
-	"%psr", " %pc", "%npc", "  %y", "%wim", "%tbr"
-#endif
-};
-#endif	/* __sparc */
-
 #if defined(__amd64)
 static const char * const regname[NPRGREG] = {
 	"%r15", "%r14", "%r13", "%r12", "%r11", "%r10", " %r9", " %r8",
@@ -611,45 +582,3 @@
 	if (i % cols != 0)
 		(void) putchar('\n');
 }
-
-#if defined(__sparc) && defined(_ILP32)
-static void
-dumpregs_v8p(const prgregset_t reg, const prxregset_t *xreg, int is64)
-{
-	static const uint32_t zero[8] = { 0 };
-	int gr, xr, cols = 2;
-	uint64_t xval;
-
-	if (memcmp(xreg->pr_un.pr_v8p.pr_xg, zero, sizeof (zero)) == 0 &&
-	    memcmp(xreg->pr_un.pr_v8p.pr_xo, zero, sizeof (zero)) == 0) {
-		dumpregs(reg, is64);
-		return;
-	}
-
-	for (gr = R_G0, xr = XR_G0; gr <= R_G7; gr++, xr++) {
-		xval = (uint64_t)xreg->pr_un.pr_v8p.pr_xg[xr] << 32 |
-		    (uint64_t)(uint32_t)reg[gr];
-		(void) printf("  %s = 0x%.16" PRIX64, regname[gr], xval);
-		if ((gr + 1) % cols == 0)
-			(void) putchar('\n');
-	}
-
-	for (gr = R_O0, xr = XR_O0; gr <= R_O7; gr++, xr++) {
-		xval = (uint64_t)xreg->pr_un.pr_v8p.pr_xo[xr] << 32 |
-		    (uint64_t)(uint32_t)reg[gr];
-		(void) printf("  %s = 0x%.16" PRIX64, regname[gr], xval);
-		if ((gr + 1) % cols == 0)
-			(void) putchar('\n');
-	}
-
-	for (gr = R_L0; gr < NPRGREG; gr++) {
-		(void) printf("  %s =         0x%.8lX",
-		    regname[gr], (long)reg[gr]);
-		if ((gr + 1) % cols == 0)
-			(void) putchar('\n');
-	}
-
-	if (gr % cols != 0)
-		(void) putchar('\n');
-}
-#endif	/* __sparc && _ILP32 */
--- old/usr/src/cmd/truss/systable.c	Wed Apr 12 20:33:20 2023
+++ new/usr/src/cmd/truss/systable.c	Wed Apr 12 20:33:20 2023
@@ -681,6 +681,7 @@
 {"setcontext",	2, DEC, NOV, HID, HEX},				/* 1 */
 {"getustack",	2, DEC, NOV, HID, HEX},				/* 2 */
 {"setustack",	2, DEC, NOV, HID, HEX},				/* 3 */
+{"getcontext_extd",	2, DEC, NOV, HID, HEX},				/* 4 */
 };
 #define	NCTXCODE	(sizeof (ctxtable) / sizeof (struct systable))
 
--- old/usr/src/head/proc_service.h	Wed Apr 12 20:33:20 2023
+++ new/usr/src/head/proc_service.h	Wed Apr 12 20:33:20 2023
@@ -56,7 +56,8 @@
 	PS_BADLID,	/* bad lwp identifier */
 	PS_BADADDR,	/* bad address */
 	PS_NOSYM,	/* p_lookup() could not find given symbol */
-	PS_NOFREGS	/* FPU register set not available for given lwp */
+	PS_NOFREGS,	/* FPU register set not available for given lwp */
+	PS_NOXREGS	/* extended register set not available for given lwp */
 } ps_err_e;
 
 struct ps_prochandle;
@@ -118,11 +119,9 @@
 extern ps_err_e ps_lsetfpregs(struct ps_prochandle *,
 			lwpid_t, const prfpregset_t *);
 
-#if defined(__sparc) || defined(__sparcv9)
 extern ps_err_e ps_lgetxregsize(struct ps_prochandle *, lwpid_t, int *);
 extern ps_err_e ps_lgetxregs(struct ps_prochandle *, lwpid_t, caddr_t);
 extern ps_err_e ps_lsetxregs(struct ps_prochandle *, lwpid_t, caddr_t);
-#endif
 
 #if defined(__i386) || defined(__amd64)
 extern ps_err_e ps_lgetLDT(struct ps_prochandle *, lwpid_t, struct ssd *);
--- old/usr/src/head/stdalign.h	Wed Apr 12 20:33:20 2023
+++ new/usr/src/head/stdalign.h	Wed Apr 12 20:33:20 2023
@@ -10,46 +10,12 @@
  */
 
 /*
- * Copyright 2016 Joyent, Inc.
- * Copyright 2022 Oxide Computer Company
+ * Copyright 2023 Oxide Computer Company
  */
 
 #ifndef _STDALIGN_H
 #define	_STDALIGN_H
 
-/*
- * ISO/IEC C11 stdalign.h. This header is meant to provide definitions for the
- * alignas and alignof 'keywords' into the underlying compiler-understood value.
- * In addition, there are two macros that are meant to define that this process
- * has happened. C++11 added alignas/alignof as keywords and including this
- * header is meant to cause us to still have the _is_defined macros, but not
- * define this overall.
- *
- * Unlike other cases we don't use any symbol guards here (other than C++) and
- * just allow the implementation to either have _Alignas and _Alignof or not
- * have it and lead to a compiler error for the user. The main justification of
- * this is that this header is only defined in C11 (and newer). It's not defined
- * in other standards and just as if you include a non-standard header, in this
- * case we don't try to stop that (same as if you included something like
- * libdevinfo.h).
- */
+#include <sys/stdalign.h>
 
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-#ifndef	__cplusplus
-
-#define	alignas	_Alignas
-#define	alignof	_Alignof
-
-#endif	/* !__cplusplus */
-
-#define	__alignas_is_defined	1
-#define	__alignof_is_defined	1
-
-#ifdef __cplusplus
-}
-#endif
-
 #endif /* _STDALIGN_H */
--- old/usr/src/head/ucontext.h	Wed Apr 12 20:33:20 2023
+++ new/usr/src/head/ucontext.h	Wed Apr 12 20:33:20 2023
@@ -24,6 +24,7 @@
 
 /*
  * Copyright 2014 Garrett D'Amore <garrett@damore.org>
+ * Copyright 2023 Oxide Computer Company
  *
  * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
@@ -47,6 +48,7 @@
 #if !defined(_XPG4_2) || defined(__EXTENSIONS__)
 #include <sys/regset.h>
 #include <sys/siginfo.h>
+#include <sys/int_types.h>
 #endif
 
 #ifdef	__cplusplus
@@ -63,12 +65,18 @@
 
 extern int getcontext(ucontext_t *) __RETURNS_TWICE;
 #pragma unknown_control_flow(getcontext)
-extern int setcontext(const ucontext_t *) __NORETURN;
+extern int setcontext(const ucontext_t *);
 extern int swapcontext(ucontext_t *_RESTRICT_KYWD,
 		const ucontext_t *_RESTRICT_KYWD);
 extern void makecontext(ucontext_t *, void(*)(), int, ...);
 
 #if !defined(_XPG4_2) || defined(__EXTENSIONS__)
+extern ucontext_t *ucontext_alloc(uint32_t);
+extern void ucontext_free(ucontext_t *);
+extern int getcontext_extd(ucontext_t *, uint32_t) __RETURNS_TWICE;
+#pragma unknown_control_flow(getcontext_extd)
+extern int swapcontext_extd(ucontext_t *_RESTRICT_KYWD, uint32_t,
+		const ucontext_t *_RESTRICT_KYWD);
 extern int walkcontext(const ucontext_t *, int (*)(uintptr_t, int, void *),
     void *);
 extern int printstack(int);
--- old/usr/src/lib/libc/amd64/gen/makectxt.c	Wed Apr 12 20:33:20 2023
+++ new/usr/src/lib/libc/amd64/gen/makectxt.c	Wed Apr 12 20:33:20 2023
@@ -25,8 +25,12 @@
  */
 
 /*	Copyright (c) 1988 AT&T	*/
-/*	  All Rights Reserved  	*/
+/*	  All Rights Reserved	*/
 
+/*
+ * Copyright 2023 Oxide Computer Company
+ */
+
 #pragma weak _makecontext = makecontext
 
 #include "lint.h"
@@ -33,6 +37,9 @@
 #include <stdarg.h>
 #include <ucontext.h>
 #include <sys/stack.h>
+#include <sys/auxv.h>
+#include <errno.h>
+#include "libc.h"
 
 /*
  * The ucontext_t that the user passes in must have been primed with a
@@ -119,4 +126,63 @@
 
 	(void) getcontext(&uc);
 	(void) setcontext(uc.uc_link);
+}
+
+/*
+ * This is the ISA-specific allocation logic for allocating and setting up an
+ * extended ucontext_t. In particular, right now we need to allocate and add
+ * space for the UC_XSAVE member if we have the appropriate hardware support.
+ * The i386 / amd64 versions could be consolidated in a single x86 impl, but we
+ * don't have that right now.
+ */
+ucontext_t *
+ucontext_alloc(uint32_t flags)
+{
+	boolean_t do_xsave = B_FALSE;
+	size_t to_alloc = sizeof (ucontext_t);
+	ucontext_t *ucp;
+
+	if (flags != 0) {
+		errno = EINVAL;
+		return (NULL);
+	}
+
+	/*
+	 * This value isn't really 100% accurate. The xsave size is basically
+	 * the worst case that we can have. The XMM / xsave structures aren't
+	 * included in here, but are going to be enough to cover this. We can
+	 * probably try to do a little better and should consider asking the
+	 * kernel for something more accurate. In particular, the problem with
+	 * this is that it doesn't account for the right size of future-looking
+	 * dynamic things, but then again neither does rtld. We'll deal with
+	 * this when we have support for the xfd MSR and actually use it. For
+	 * more information see uts/intel/os/fpu.c's big theory statement.
+	 */
+	switch (___getauxval(AT_SUN_FPTYPE)) {
+	case AT_386_FPINFO_XSAVE:
+	case AT_386_FPINFO_XSAVE_AMD:
+		do_xsave = B_TRUE;
+		to_alloc += ___getauxval(AT_SUN_FPSIZE);
+		break;
+	default:
+		break;
+	}
+
+	ucp = calloc(1, to_alloc);
+	if (ucp == NULL) {
+		return (NULL);
+	}
+
+	if (do_xsave) {
+		uintptr_t addr = (uintptr_t)ucp;
+		ucp->uc_xsave = addr + sizeof (ucontext_t);
+	}
+
+	return (ucp);
+}
+
+void
+ucontext_free(ucontext_t *ucp)
+{
+	free(ucp);
 }
--- old/usr/src/lib/libc/amd64/gen/siglongjmp.c	Wed Apr 12 20:33:20 2023
+++ new/usr/src/lib/libc/amd64/gen/siglongjmp.c	Wed Apr 12 20:33:20 2023
@@ -24,11 +24,17 @@
  * Use is subject to license terms.
  */
 
+/*
+ * Copyright 2023 Oxide Computer Company
+ */
+
 #include "lint.h"
 #include <sys/types.h>
 #include <sys/ucontext.h>
 #include <setjmp.h>
 #include <ucontext.h>
+#include <strings.h>
+#include <upanic.h>
 #include "sigjmp_struct.h"
 #include "libc.h"
 
@@ -37,6 +43,7 @@
 void
 siglongjmp(sigjmp_buf env, int val)
 {
+	const char *msg = "siglongjmp(): setcontext() returned";
 	ucontext_t *ucp = SIGJMP2UCONTEXT(env);
 
 	if (val)
@@ -44,5 +51,10 @@
 	else
 		ucp->uc_mcontext.gregs[REG_R0] = 1;
 
+	/*
+	 * While unlikely, it is possible that setcontext() may fail for some
+	 * reason. If that happens, we will kill the process.
+	 */
 	(void) setcontext(ucp);
+	upanic(msg, strlen(msg) + 1);
 }
--- old/usr/src/lib/libc/amd64/sys/__getcontext.S	Wed Apr 12 20:33:21 2023
+++ new/usr/src/lib/libc/amd64/sys/__getcontext.S	Wed Apr 12 20:33:21 2023
@@ -24,6 +24,10 @@
  * Use is subject to license terms.
  */
 
+/*
+ * Copyright 2023 Oxide Computer Company
+ */
+
 	.file	"__getcontext.s"
 
 /*
@@ -41,3 +45,11 @@
 	SYSCERROR
 	RETC
 	SET_SIZE(__getcontext)
+
+	ENTRY(__getcontext_extd)
+	movq	%rdi, %rsi
+	movq	$4, %rdi
+	SYSTRAP_RVAL1(context)
+	SYSCERROR
+	RETC
+	SET_SIZE(__getcontext_extd)
--- old/usr/src/lib/libc/amd64/sys/getcontext.S	Wed Apr 12 20:33:21 2023
+++ new/usr/src/lib/libc/amd64/sys/getcontext.S	Wed Apr 12 20:33:21 2023
@@ -24,6 +24,10 @@
  * Use is subject to license terms.
  */
 
+/*
+ * Copyright 2023 Oxide Computer Company
+ */
+
 	.file	"getcontext.s"
 
 #include <sys/asm_linkage.h>
@@ -42,9 +46,9 @@
  * swapcontext() shares the most code with getcontext().
  */
 
-#define	GETCONTEXT_IMPL(offset)						\
+#define	GETCONTEXT_IMPL(offset, func)						\
 	pushq	%rdi;		/* preserve the ucontext_t pointer */	\
-	call	__getcontext;						\
+	call	func;						\
 				/* call getcontext: syscall */		\
 	popq	%rdx;							\
 	andl	%eax, %eax;	/* if (error_return_from_syscall) */	\
@@ -69,26 +73,59 @@
 	movq	%rax, RAX_OFF (%rdx);					\
 				/* getcontext returns 0 after setcontext */
 
-/*	
- * getcontext(ucontext_t *ucp)
+/*
+ * int getcontext(ucontext_t *ucp)
  */
 
 	ENTRY(getcontext)
-	GETCONTEXT_IMPL(0)
+	GETCONTEXT_IMPL(0, __getcontext)
 	ret
 	SET_SIZE(getcontext)
 
 /*
- * swapcontext(ucontext_t *oucp, const ucontext_t *ucp)
+ * int swapcontext(ucontext_t *oucp, const ucontext_t *ucp)
  */
 
 	ENTRY(swapcontext)
 	pushq	%rsi			/* preserve the 2nd argument */
-	
-	GETCONTEXT_IMPL(8)
 
+	GETCONTEXT_IMPL(8, __getcontext)
+
 	/* call setcontext */
 	popq	%rdi
 	call	setcontext
 	ret
 	SET_SIZE(swapcontext)
+
+/*
+ * int getcontext_extd(ucontext_t * ctx, uint32_t flags)
+ */
+	ENTRY(getcontext_extd)
+	cmpl	$0, %esi
+	jne	2f
+	GETCONTEXT_IMPL(0, __getcontext_extd)
+	ret
+2:
+	movl	$EINVAL, %eax		/* errno = EINVAL */
+	jmp	__cerror		/* return (-1) */
+	SET_SIZE(getcontext_extd)
+
+/*
+ * int swapcontext_extd(ucontext_t *oucp, uint32_t flags, const ucontext_t *ucp)
+ */
+
+	ENTRY(swapcontext_extd)
+	cmpl	$0, %esi
+	jne	2f
+	pushq	%rdx			/* preserve the 3rd argument */
+
+	GETCONTEXT_IMPL(8, __getcontext_extd)
+
+	/* call setcontext */
+	popq	%rdi
+	call	setcontext
+	ret
+2:
+	movl	$EINVAL, %eax		/* errno = EINVAL */
+	jmp	__cerror		/* return (-1) */
+	SET_SIZE(swapcontext_extd)
--- old/usr/src/lib/libc/i386/fp/fpstart.c	Wed Apr 12 20:33:21 2023
+++ new/usr/src/lib/libc/i386/fp/fpstart.c	Wed Apr 12 20:33:21 2023
@@ -31,6 +31,10 @@
  */
 
 /*
+ * Copyright 2023 Oxide Computer Company
+ */
+
+/*
  * Establish the default settings for the floating-point state for a C language
  * program:
  *	rounding mode		-- round to nearest default by OS,
@@ -48,6 +52,7 @@
 #include	<sys/types.h>
 #include	<sys/sysi86.h>	/* for SI86FPHW/SI86FPSTART definitions */
 #include	<sys/fp.h>	/* for FPU_CW_INIT and SSE_MXCSR_INIT */
+#include	<upanic.h>
 
 extern int	__fltrounds();
 
@@ -55,6 +60,8 @@
 int	_sse_hw;		/* default: bss: 0 == no sse */
 int	__flt_rounds;		/* ANSI rounding mode */
 
+#define	UPANIC_MSG	"32-bit FPU init failed!"
+
 void
 __fpstart()
 {
@@ -64,14 +71,14 @@
 	 */
 	if ((_sse_hw = sysi86(SI86FPSTART,
 	    &_fp_hw, FPU_CW_INIT, SSE_MXCSR_INIT)) == -1) {
-		extern void _putcw();
-
 		/*
-		 * (fallback to old syscall on old kernels)
+		 * Because the system only supports a 64-bit kernel, the above
+		 * should always work (we assume it does in 64-bit libc). If it
+		 * should fail, we upanic. Note, because the FPU state is
+		 * unknown, we use a static message below and don't rely upon
+		 * strlen(), but rather constant time lengths.
 		 */
-		_sse_hw = 0;
-		(void) sysi86(SI86FPHW, &_fp_hw);
-		_putcw(0x133f);
+		upanic(UPANIC_MSG, sizeof (UPANIC_MSG));
 	}
 
 	/*
--- old/usr/src/lib/libc/i386/gen/makectxt.c	Wed Apr 12 20:33:21 2023
+++ new/usr/src/lib/libc/i386/gen/makectxt.c	Wed Apr 12 20:33:21 2023
@@ -25,8 +25,12 @@
  */
 
 /*	Copyright (c) 1988 AT&T	*/
-/*	  All Rights Reserved  	*/
+/*	  All Rights Reserved	*/
 
+/*
+ * Copyright 2023 Oxide Computer Company
+ */
+
 #pragma weak _makecontext = makecontext
 
 #include "lint.h"
@@ -33,6 +37,9 @@
 #include <stdarg.h>
 #include <ucontext.h>
 #include <sys/stack.h>
+#include <sys/auxv.h>
+#include <errno.h>
+#include "libc.h"
 
 /*
  * The ucontext_t that the user passes in must have been primed with a
@@ -115,4 +122,63 @@
 
 	(void) getcontext(&uc);
 	(void) setcontext(uc.uc_link);
+}
+
+/*
+ * This is the ISA-specific allocation logic for allocating and setting up an
+ * extended ucontext_t. In particular, right now we need to allocate and add
+ * space for the UC_XSAVE member if we have the appropriate hardware support.
+ * The i386 / amd64 versions could be consolidated in a single x86 impl, but we
+ * don't have that right now.
+ */
+ucontext_t *
+ucontext_alloc(uint32_t flags)
+{
+	boolean_t do_xsave = B_FALSE;
+	size_t to_alloc = sizeof (ucontext_t);
+	ucontext_t *ucp;
+
+	if (flags != 0) {
+		errno = EINVAL;
+		return (NULL);
+	}
+
+	/*
+	 * This value isn't really 100% accurate. The xsave size is basically
+	 * the worst case that we can have. The XMM / xsave structures aren't
+	 * included in here, but are going to be enough to cover this. We can
+	 * probably try to do a little better and should consider asking the
+	 * kernel for something more accurate. In particular, the problem with
+	 * tis is that it doesn't account for the right size of future-looking
+	 * dynamic things, but then again neither does rtld. We'll deal with
+	 * this when we have support for the xfd MSR and actually use it. For
+	 * more information see uts/intel/os/fpu.c's big theory statement.
+	 */
+	switch (___getauxval(AT_SUN_FPTYPE)) {
+	case AT_386_FPINFO_XSAVE:
+	case AT_386_FPINFO_XSAVE_AMD:
+		do_xsave = B_TRUE;
+		to_alloc += ___getauxval(AT_SUN_FPSIZE);
+		break;
+	default:
+		break;
+	}
+
+	ucp = calloc(1, to_alloc);
+	if (ucp == NULL) {
+		return (NULL);
+	}
+
+	if (do_xsave) {
+		uintptr_t addr = (uintptr_t)ucp;
+		ucp->uc_xsave = addr + sizeof (ucontext_t);
+	}
+
+	return (ucp);
+}
+
+void
+ucontext_free(ucontext_t *ucp)
+{
+	free(ucp);
 }
--- old/usr/src/lib/libc/i386/gen/siglongjmp.c	Wed Apr 12 20:33:21 2023
+++ new/usr/src/lib/libc/i386/gen/siglongjmp.c	Wed Apr 12 20:33:21 2023
@@ -28,11 +28,17 @@
 /*	Copyright (c) 1988 AT&T	*/
 /*	  All Rights Reserved	*/
 
+/*
+ * Copyright 2023 Oxide Computer Company
+ */
+
 #include "lint.h"
 #include <sys/types.h>
 #include <sys/ucontext.h>
 #include <setjmp.h>
 #include <ucontext.h>
+#include <strings.h>
+#include <upanic.h>
 #include "libc.h"
 
 #pragma weak _siglongjmp = siglongjmp
@@ -40,6 +46,7 @@
 void
 siglongjmp(sigjmp_buf env, int val)
 {
+	const char *msg = "siglongjmp(): setcontext() returned";
 	ucontext_t *ucp = (ucontext_t *)env;
 
 	if (val)
@@ -47,5 +54,10 @@
 	else
 		ucp->uc_mcontext.gregs[EAX] = 1;
 
+	/*
+	 * While unlikely, it is possible that setcontext() may fail for some
+	 * reason. If that happens, we will kill the process.
+	 */
 	(void) setcontext(ucp);
+	upanic(msg, strlen(msg) + 1);
 }
--- old/usr/src/lib/libc/i386/sys/__getcontext.S	Wed Apr 12 20:33:21 2023
+++ new/usr/src/lib/libc/i386/sys/__getcontext.S	Wed Apr 12 20:33:21 2023
@@ -24,6 +24,10 @@
  * Use is subject to license terms.
  */
 
+/*
+ * Copyright 2023 Oxide Computer Company
+ */
+
 	.file	"__getcontext.s"
 
 /*
@@ -44,3 +48,14 @@
 	SYSCERROR
 	RET
 	SET_SIZE(__getcontext)
+
+	ENTRY(__getcontext_extd)
+	popl	%edx
+	pushl	$4
+	pushl	%edx
+	SYSTRAP_RVAL1(context)
+	popl	%edx
+	movl	%edx, 0(%esp)
+	SYSCERROR
+	RET
+	SET_SIZE(__getcontext_extd)
--- old/usr/src/lib/libc/i386/sys/getcontext.S	Wed Apr 12 20:33:21 2023
+++ new/usr/src/lib/libc/i386/sys/getcontext.S	Wed Apr 12 20:33:21 2023
@@ -24,6 +24,10 @@
  * Use is subject to license terms.
  */
 
+/*
+ * Copyright 2023 Oxide Computer Company
+ */
+
 	.file	"getcontext.s"
 
 #include <sys/asm_linkage.h>
@@ -44,10 +48,10 @@
  */
 
 
-#define	GETCONTEXT_IMPL							\
+#define	GETCONTEXT_IMPL(func)						\
 	movl	4(%esp), %eax;		/* %eax <-- first arg: ucp */	\
 	pushl	%eax;			/* push ucp for system call */	\
-	call	__getcontext;		/* call getcontext: syscall */	\
+	call	func;			/* call getcontext: syscall */	\
 	addl	$4, %esp;		/* pop arg */			\
 	andl	%eax, %eax;		/* if (err_ret_from_syscall) */	\
 	je	1f;							\
@@ -70,20 +74,20 @@
 				/* getcontext returns 0 after a setcontext */
 
 /*
- * getcontext(ucontext_t *ucp)
+ * int getcontext(ucontext_t *ucp)
  */
 	ENTRY(getcontext)
-	GETCONTEXT_IMPL
+	GETCONTEXT_IMPL(__getcontext)
 	ret
 	SET_SIZE(getcontext)
 
 
 /*
- * swapcontext(ucontext_t *oucp, const ucontext_t *ucp)
+ * int swapcontext(ucontext_t *oucp, const ucontext_t *ucp)
  */
 	ENTRY(swapcontext)
-	GETCONTEXT_IMPL
-	/ call setcontext
+	GETCONTEXT_IMPL(__getcontext)
+	/* call setcontext */
 	movl	8(%esp), %eax		/* %eax <-- second arg: ucp */
 	pushl	%eax			/* push ucp for setcontext */
 	call	setcontext
@@ -90,3 +94,37 @@
 	addl	$4, %esp		/* pop arg: just in case */
 	ret
 	SET_SIZE(swapcontext)
+
+/*
+ * int getcontext_extd(ucontext_t *ucp, uint32_t flags)
+ */
+	ENTRY(getcontext_extd)
+	movl	8(%esp), %eax
+	cmpl	$0, %eax		/* if (flags != 0) */
+	jne	2f
+	GETCONTEXT_IMPL(__getcontext_extd)
+	ret
+2:
+	movl	$EINVAL, %eax		/* errno = EINVAL; */
+	jmp	__cerror		/* return (-1) */
+	SET_SIZE(getcontext_extd)
+
+
+/*
+ * int swapcontext_extd(ucontext_t *oucp, const ucontext_t *ucp)
+ */
+	ENTRY(swapcontext_extd)
+	movl	8(%esp), %eax
+	cmpl	$0, %eax		/* if (flags != 0) */
+	jne	2f
+	GETCONTEXT_IMPL(__getcontext_extd)
+	/* call setcontext */
+	movl	12(%esp), %eax		/* %eax <-- second arg: ucp */
+	pushl	%eax			/* push ucp for setcontext */
+	call	setcontext
+	addl	$4, %esp		/* pop arg: just in case */
+	ret
+2:
+	movl	$EINVAL, %eax		/* errno = EINVAL; */
+	jmp	__cerror		/* return (-1) */
+	SET_SIZE(swapcontext_extd)
--- old/usr/src/lib/libc/inc/libc.h	Wed Apr 12 20:33:21 2023
+++ new/usr/src/lib/libc/inc/libc.h	Wed Apr 12 20:33:21 2023
@@ -230,6 +230,7 @@
  * defined in ucontext.s
  */
 extern int __getcontext(ucontext_t *);
+extern int __getcontext_extd(ucontext_t *);
 
 /*
  * defined in door.s
@@ -346,6 +347,12 @@
 extern size_t mbrtowc_nz(wchar_t *_RESTRICT_KYWD, const char *_RESTRICT_KYWD,
     size_t, mbstate_t *_RESTRICT_KYWD);
 
+/*
+ * defined in getauxv.c.
+ */
+extern long ___getauxval(int);
+extern void *___getauxptr(int);
+
 #ifdef	__cplusplus
 }
 #endif
--- old/usr/src/lib/libc/port/mapfile-vers	Wed Apr 12 20:33:22 2023
+++ new/usr/src/lib/libc/port/mapfile-vers	Wed Apr 12 20:33:22 2023
@@ -78,6 +78,14 @@
 $add amd64
 $endif
 
+SYMBOL_VERSION ILLUMOS_0.41 {
+    protected:
+	getcontext_extd;
+	swapcontext_extd;
+	ucontext_alloc;
+	ucontext_free;
+} ILLUMOS_0.40;
+
 SYMBOL_VERSION ILLUMOS_0.40 {
     protected:
 	errc;
--- old/usr/src/lib/libc_db/common/thread_db.c	Wed Apr 12 20:33:22 2023
+++ new/usr/src/lib/libc_db/common/thread_db.c	Wed Apr 12 20:33:22 2023
@@ -26,6 +26,7 @@
 
 /*
  * Copyright (c) 2014, Joyent, Inc. All rights reserved.
+ * Copyright 2023 Oxide Computer Company
  */
 
 #include <stdio.h>
@@ -1989,7 +1990,6 @@
 td_err_e
 __td_thr_getxregsize(td_thrhandle_t *th_p, int *xregsize)
 {
-#if defined(__sparc)
 	struct ps_prochandle *ph_p;
 	td_err_e return_val;
 
@@ -2003,12 +2003,12 @@
 	if (ps_lgetxregsize(ph_p, thr_to_lwpid(th_p), xregsize) != PS_OK)
 		return_val = TD_DBERR;
 
+	if (*xregsize == 0)
+		return_val = TD_NOXREGS;
+
 	(void) ps_pcontinue(ph_p);
 	ph_unlock(th_p->th_ta_p);
 	return (return_val);
-#else	/* __sparc */
-	return (TD_NOXREGS);
-#endif	/* __sparc */
 }
 
 /*
@@ -2015,13 +2015,12 @@
  * Get a thread's extra state register set.
  */
 #pragma weak td_thr_getxregs = __td_thr_getxregs
-/* ARGSUSED */
 td_err_e
 __td_thr_getxregs(td_thrhandle_t *th_p, void *xregset)
 {
-#if defined(__sparc)
 	struct ps_prochandle *ph_p;
 	td_err_e return_val;
+	ps_err_e ps_err;
 
 	if ((ph_p = ph_lock_th(th_p, &return_val)) == NULL)
 		return (return_val);
@@ -2030,15 +2029,15 @@
 		return (TD_DBERR);
 	}
 
-	if (ps_lgetxregs(ph_p, thr_to_lwpid(th_p), (caddr_t)xregset) != PS_OK)
+	ps_err = ps_lgetxregs(ph_p, thr_to_lwpid(th_p), (caddr_t)xregset);
+	if (ps_err == PS_NOXREGS)
+		return_val = TD_NOXREGS;
+	else if (ps_err != PS_OK)
 		return_val = TD_DBERR;
 
 	(void) ps_pcontinue(ph_p);
 	ph_unlock(th_p->th_ta_p);
 	return (return_val);
-#else	/* __sparc */
-	return (TD_NOXREGS);
-#endif	/* __sparc */
 }
 
 /*
@@ -2049,7 +2048,6 @@
 td_err_e
 __td_thr_setxregs(td_thrhandle_t *th_p, const void *xregset)
 {
-#if defined(__sparc)
 	struct ps_prochandle *ph_p;
 	td_err_e return_val;
 
@@ -2066,9 +2064,6 @@
 	(void) ps_pcontinue(ph_p);
 	ph_unlock(th_p->th_ta_p);
 	return (return_val);
-#else	/* __sparc */
-	return (TD_NOXREGS);
-#endif	/* __sparc */
 }
 
 struct searcher {
--- old/usr/src/lib/libproc/common/Pcontrol.c	Wed Apr 12 20:33:22 2023
+++ new/usr/src/lib/libproc/common/Pcontrol.c	Wed Apr 12 20:33:22 2023
@@ -28,7 +28,7 @@
  * Copyright (c) 2013 by Delphix. All rights reserved.
  * Copyright 2015, Joyent, Inc.
  * Copyright 2020 OmniOS Community Edition (OmniOSce) Association.
- * Copyright 2021 Oxide Computer Company
+ * Copyright 2023 Oxide Computer Company
  */
 
 #include <assert.h>
@@ -3155,7 +3155,7 @@
  * or it will point to an empty slot for a new struct ps_lwphandle.
  */
 static struct ps_lwphandle **
-Lfind(struct ps_prochandle *P, lwpid_t lwpid)
+Lfind_slot(struct ps_prochandle *P, lwpid_t lwpid)
 {
 	struct ps_lwphandle **Lp;
 	struct ps_lwphandle *L;
@@ -3168,6 +3168,20 @@
 }
 
 /*
+ * A wrapper around Lfind_slot() that is suitable for the rest of the internal
+ * consumers who don't care about a slot, merely existence.
+ */
+struct ps_lwphandle *
+Lfind(struct ps_prochandle *P, lwpid_t lwpid)
+{
+	if (P->hashtab == NULL) {
+		return (NULL);
+	}
+
+	return (*Lfind_slot(P, lwpid));
+}
+
+/*
  * Grab an LWP contained within the controlled process.
  * Return an opaque pointer to its LWP control structure.
  *	perr: pointer to error return code.
@@ -3190,7 +3204,7 @@
 	    (P->hashtab = calloc(HASHSIZE, sizeof (struct ps_lwphandle *)))
 	    == NULL)
 		rc = G_STRANGE;
-	else if (*(Lp = Lfind(P, lwpid)) != NULL)
+	else if (*(Lp = Lfind_slot(P, lwpid)) != NULL)
 		rc = G_BUSY;
 	else if ((L = malloc(sizeof (struct ps_lwphandle))) == NULL)
 		rc = G_STRANGE;
@@ -3332,7 +3346,7 @@
 static void
 Lfree_internal(struct ps_prochandle *P, struct ps_lwphandle *L)
 {
-	*Lfind(P, L->lwp_id) = L->lwp_hash;	/* delete from hash table */
+	*Lfind_slot(P, L->lwp_id) = L->lwp_hash; /* delete from hash table */
 	if (L->lwp_ctlfd >= 0)
 		(void) close(L->lwp_ctlfd);
 	if (L->lwp_statfd >= 0)
@@ -3438,7 +3452,7 @@
  * Or, just get the current status (PCNULL).
  * Or, direct it to stop and get the current status (PCDSTOP).
  */
-static int
+int
 Lstopstatus(struct ps_lwphandle *L,
     long request,		/* PCNULL, PCDSTOP, PCSTOP, PCWSTOP */
     uint_t msec)		/* if non-zero, timeout in milliseconds */
--- old/usr/src/lib/libproc/common/Pcontrol.h	Wed Apr 12 20:33:22 2023
+++ new/usr/src/lib/libproc/common/Pcontrol.h	Wed Apr 12 20:33:22 2023
@@ -27,7 +27,7 @@
  * Copyright (c) 2013 by Delphix. All rights reserved.
  * Copyright 2018 Joyent, Inc.
  * Copyright 2020 OmniOS Community Edition (OmniOSce) Association.
- * Copyright 2021 Oxide Computer Company
+ * Copyright 2023 Oxide Computer Company
  */
 
 #ifndef	_PCONTROL_H
@@ -144,9 +144,10 @@
 	lwpsinfo_t lwp_psinfo;	/* /proc/<pid>/lwp/<lwpid>/lwpsinfo data */
 	lwpstatus_t lwp_status;	/* /proc/<pid>/lwp/<lwpid>/lwpstatus data */
 	char lwp_name[THREAD_NAME_MAX];
+	prxregset_t *lwp_xregs;	/* /proc/<pid>/lwp/<lwpid>/xregs data */
+	size_t lwp_xregsize;
 #if defined(sparc) || defined(__sparc)
 	gwindows_t *lwp_gwins;	/* /proc/<pid>/lwp/<lwpid>/gwindows data */
-	prxregset_t *lwp_xregs;	/* /proc/<pid>/lwp/<lwpid>/xregs data */
 	int64_t *lwp_asrs;	/* /proc/<pid>/lwp/<lwpid>/asrs data */
 #endif
 } lwp_info_t;
@@ -298,6 +299,8 @@
 extern	int	Padd_mapping(struct ps_prochandle *, off64_t, file_info_t *,
     prmap_t *);
 extern	void	Psort_mappings(struct ps_prochandle *);
+extern	struct ps_lwphandle *Lfind(struct ps_prochandle *, lwpid_t);
+extern	int	Lstopstatus(struct ps_lwphandle *, long, uint_t);
 
 extern char	procfs_path[PATH_MAX];
 
--- old/usr/src/lib/libproc/common/Pcore.c	Wed Apr 12 20:33:23 2023
+++ new/usr/src/lib/libproc/common/Pcore.c	Wed Apr 12 20:33:23 2023
@@ -28,7 +28,7 @@
  * Copyright (c) 2013 by Delphix. All rights reserved.
  * Copyright 2015 Gary Mills
  * Copyright 2020 OmniOS Community Edition (OmniOSce) Association.
- * Copyright 2021 Oxide Computer Company
+ * Copyright 2023 Oxide Computer Company
  */
 
 #include <sys/types.h>
@@ -1081,22 +1081,30 @@
 	return (0);
 }
 
-#ifdef __sparc
+/*
+ * The xregs are not a fixed size on all architectures (notably x86) and in
+ * general the prxregset_t has become opaque to deal with this. This means that
+ * validating the note itself can be a little more challenging. Especially as
+ * this can change across time. In this case we require that our consumers
+ * perform this validation right now ala what mdb does before using the xregs
+ * data.
+ */
 static int
 note_xreg(struct ps_prochandle *P, size_t nbytes)
 {
 	core_info_t *core = P->data;
 	lwp_info_t *lwp = core->core_lwp;
-	size_t xbytes = sizeof (prxregset_t);
 	prxregset_t *xregs;
+	ssize_t sret;
 
-	if (lwp == NULL || lwp->lwp_xregs != NULL || nbytes < xbytes)
+	if (lwp == NULL || lwp->lwp_xregs != NULL)
 		return (0);	/* No lwp yet, already seen, or bad size */
 
-	if ((xregs = malloc(xbytes)) == NULL)
+	if ((xregs = malloc(nbytes)) == NULL)
 		return (-1);
 
-	if (read(P->asfd, xregs, xbytes) != xbytes) {
+	sret = read(P->asfd, xregs, nbytes);
+	if (sret < 0 || (size_t)sret != nbytes) {
 		dprintf("Pgrab_core: failed to read NT_PRXREG\n");
 		free(xregs);
 		return (-1);
@@ -1103,9 +1111,11 @@
 	}
 
 	lwp->lwp_xregs = xregs;
+	lwp->lwp_xregsize = nbytes;
 	return (0);
 }
 
+#ifdef __sparc
 static int
 note_gwindows(struct ps_prochandle *P, size_t nbytes)
 {
@@ -1254,11 +1264,7 @@
 #else
 	note_notsup,		/*  3	NT_PRPSINFO (old)	*/
 #endif
-#ifdef __sparc
 	note_xreg,		/*  4	NT_PRXREG		*/
-#else
-	note_notsup,		/*  4	NT_PRXREG		*/
-#endif
 	note_platform,		/*  5	NT_PLATFORM		*/
 	note_auxv,		/*  6	NT_AUXV			*/
 #ifdef __sparc
--- old/usr/src/lib/libproc/common/Pgcore.c	Wed Apr 12 20:33:23 2023
+++ new/usr/src/lib/libproc/common/Pgcore.c	Wed Apr 12 20:33:23 2023
@@ -28,7 +28,7 @@
  * Copyright 2018 Joyent, Inc.
  * Copyright (c) 2013 by Delphix. All rights reserved.
  * Copyright 2020 OmniOS Community Edition (OmniOSce) Association.
- * Copyright 2021 Oxide Computer Company
+ * Copyright 2023 Oxide Computer Company
  */
 
 #define	_STRUCTURED_PROC	1
@@ -443,16 +443,6 @@
 #endif	/* _LP64 */
 	}
 
-#ifdef sparc
-	{
-		prxregset_t xregs;
-		if (Plwp_getxregs(P, lsp->pr_lwpid, &xregs) == 0 &&
-		    write_note(pgc->pgc_fd, NT_PRXREG, &xregs,
-		    sizeof (prxregset_t), pgc->pgc_doff) != 0)
-			return (1);
-	}
-#endif	/* sparc */
-
 	return (0);
 }
 
@@ -495,40 +485,25 @@
 #endif	/* _LP64 */
 	}
 
-#ifdef sparc
 	{
-		prxregset_t xregs;
-		gwindows_t gwins;
+		prxregset_t *xregs;
 		size_t size;
 
-		if (Plwp_getxregs(P, lsp->pr_lwpid, &xregs) == 0) {
-			if (write_note(pgc->pgc_fd, NT_PRXREG, &xregs,
-			    sizeof (prxregset_t), pgc->pgc_doff) != 0)
-				return (1);
-		}
-
-		if (Plwp_getgwindows(P, lsp->pr_lwpid, &gwins) == 0 &&
-		    gwins.wbcnt > 0) {
-			size = sizeof (gwins) - sizeof (gwins.wbuf) +
-			    gwins.wbcnt * sizeof (gwins.wbuf[0]);
-
-			if (write_note(pgc->pgc_fd, NT_GWINDOWS, &gwins, size,
+		/*
+		 * While historically this function was only present on some
+		 * architectures (despite the presence of the empty file
+		 * elsewhere), if we call this on a platform without support
+		 * it'll now fail and thus is no longer subject to
+		 * platform-specific ifdefs.
+		 */
+		if (Plwp_getxregs(P, lsp->pr_lwpid, &xregs, &size) == 0) {
+			if (write_note(pgc->pgc_fd, NT_PRXREG, xregs, size,
 			    pgc->pgc_doff) != 0)
 				return (1);
-		}
 
-	}
-#ifdef __sparcv9
-	if (P->status.pr_dmodel == PR_MODEL_LP64) {
-		asrset_t asrs;
-		if (Plwp_getasrs(P, lsp->pr_lwpid, asrs) == 0) {
-			if (write_note(pgc->pgc_fd, NT_ASRS, &asrs,
-			    sizeof (asrset_t), pgc->pgc_doff) != 0)
-				return (1);
+			Plwp_freexregs(P, xregs, size);
 		}
 	}
-#endif	/* __sparcv9 */
-#endif	/* sparc */
 
 	if (Plwp_getname(P, lsp->pr_lwpid, name.pr_lwpname,
 	    sizeof (name.pr_lwpname)) == 0) {
